/*-
 * Copyright (c) 1998 
 * Chris A. Davis, WI 53717.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE CHRIS DAVIS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE CHRIS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *      $Id$
 */



#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <curses.h>
/*#include <sys/stat.h>*/
#include <sys/types.h>
#include <time.h>
#include <math.h>
#include <signal.h>
#include <sys/types.h>

#define CONF_FILE "alarm.conf"    /* Default path to conf & save files */
#define SAVE_FILE "alarm.save"

#define WAIT_TIME 250             /* Sleep this time before 
                                     looping again (ms) */

#define STAT_BAR_V 16   /* progressing % status bar cords */
#define STAT_BAR_H 15

#define STAT_PER_V 16   /* status bar % cords */
#define STAT_PER_H 8

#define CUR_TIME_V  9   /* Current time */
#define CUR_TIME_H 28   

#define SEC_BAR_V 10    /* Secs now/SecGoal cords */
#define SEC_BAR_H 30


int accessed_save = 0;
int save = 0;


struct                  /* Details of config are placed here */
{
        time_t  time_set;
        int difftime;
} alarm_conf;

/*
struct                 
{
        int difftime;
} save_file;
*/

int quit();

beeper()
{ 
        
        int i, j;
        for(j=0;j<10;j++)
        {

                for(i=0;i<50;i++)
                {
                        beep();
                        flash();
                        usleep(50);
                }

                sleep(1);
        }

       quit();
}

int quit()
{
        erase();
        refresh();
        endwin();
        delwin(curscr);
        delwin(stdscr);
        puts("\nExiting...");
        exit(0);
}

void about()                    /*print the about*/
{
        WINDOW *about;
        

        about = newwin(LINES/2,COLS/2,5,20);

        wborder(about, 0,0,0,0,0,0,0,0);        
        mvwaddstr(about, 0, 17, "About");
        mvwaddstr(about, 4, 5,"Alarm v0.20b");
        mvwaddstr(about, 6, 5,"http://bsdbox.dynip.com/");
        mvwaddstr(about, 7, 5,"stingray@bsdbox.dynip.com");
        mvwaddstr(about, 10, 10,"Enter to continue");
        wrefresh(about);

        getchar();
        werase(about);
        delwin(about);
}


int update()                   /*update the screen*/
{
        static int done = 0;
        static int difftimea;
        static int calc = 0;
        static int loop = 0;        
        
        FILE *savef;
        time_t thetime;
        int i;
        int difftimeb, percent, pos;
        float x,y,z;
        char *ctime_ptr, *chr_ptr, str[34];
        thetime = time(NULL);        
        


        ctime_ptr = ctime(&thetime);
        chr_ptr = strchr(ctime_ptr, '\n');
         *chr_ptr = '\0';
        mvaddstr(CUR_TIME_V, CUR_TIME_H, ctime_ptr);
        
        
        if(done==0){
                if(!accessed_save){
                        difftimea = alarm_conf.time_set - thetime;
                        mvprintw(SEC_BAR_V, SEC_BAR_H, "%d/%d", 0, difftimea);
                        done++;
                } else {
                        difftimea = alarm_conf.difftime;
                        done++;
                }
        } else {       
                difftimeb = alarm_conf.time_set - thetime;

                mvprintw(SEC_BAR_V, SEC_BAR_H, "%d/%d",
                        difftimea-difftimeb ,difftimea);
                        
        }
                
        if(save){
                if((savef = fopen(SAVE_FILE, "w")) != NULL){
                        fprintf(savef, "SAVE_TIME:%d\n", alarm_conf.time_set);
                        fprintf(savef, "DIFFTIME:%d\n", difftimea);

                        fflush(savef);
                        fclose(savef);
                        quit();
                }
                quit();
        }
                
             
       
                
/*        x=thetime;
        y=alarm_conf.time_set;*/

        x=difftimeb;
        y=difftimea;
       
        z=(y-x)/y;

        percent=z*100;

        if(loop == 0 && percent > 1 || percent < 0)
        {
                loop++;
                return 0;
        }
   

/*        if(percent<0) percent = 1;*/

       /*mvprintw(STAT_PER_V, STAT_PER_H, "%d", percent);*/

        if(percent < 100 && percent >= 10)
                sprintf(str, "0%d", percent);
        else if(percent < 10)
                sprintf(str, "00%d", percent);
        else
                sprintf(str, "%d", percent);

        mvaddstr(STAT_PER_V, STAT_PER_H, str);
       /*mvprintw(0,0,"Float: %f\tDiffa: %d\tDiffb: %d", z, difftimea, 
difftimeb);*/

        if(thetime == alarm_conf.time_set+1) beeper();
       
        if((percent != 0) && (percent != 1) && (percent%2 == 0)){                     
                pos = percent/2;
                
        
                        for(i=0;i<pos;i++)
                                mvaddch(STAT_BAR_V, STAT_BAR_H+i, ACS_BLOCK);
                        calc++;
                
               /* mvaddch(STAT_BAR_V,STAT_BAR_H + pos, 219); */         
        }
}



int valid_month(char *month)    /*check month & return number*/
{
        if(!strcasecmp(month, "jan"))
                return 0;
        if(!strcasecmp(month, "feb"))
                return 1;
        if(!strcasecmp(month, "mar"))
                return 2;
        if(!strcasecmp(month, "apr"))
                return 3;
        if(!strcasecmp(month, "may"))
                return 4;
        if(!strcasecmp(month, "jun"))
                return 5;
        if(!strcasecmp(month, "jul"))
                return 6;
        if(!strcasecmp(month, "aug"))
                return 7;
        if(!strcasecmp(month, "sep"))
                return 8;
        if(!strcasecmp(month, "oct"))
                return 9;
        if(!strcasecmp(month, "nov"))
                return 10;
        if(!strcasecmp(month, "dec"))
                return 11;
                
        return -1; 
}

int parse_conf()        /* Go through the config file */
{
        struct tm thetime;
        FILE *conf, *save;
        char lbuf[203];
        char *pt, *name, *val, month[4];
        int x, y, z, len, month_int;
        int date, hh, mm, ss, year;
        int epoch_sec;
        
        if((save=fopen(SAVE_FILE, "r")) != NULL){
                while(fgets(lbuf, 200, save))
                {
                        if((name=strtok(lbuf, ":")) == NULL)
                                return 7;
                        if((val=strtok(NULL, "")) == NULL)
                                return 7;

                        if(!strcmp(name, "SAVE_TIME")){
                                if(sscanf(val, "%d", &alarm_conf.time_set) != 1)
                                        return 7;
                                continue;
                        } else if(!strcmp(name, "DIFFTIME")){
                                if(sscanf(val, "%d", &alarm_conf.difftime) != 1)
                                        return 7;
                                continue;
                        }
                }
                if(alarm_conf.time_set < time(NULL)) return 8;              
                accessed_save = 1;
                return -1;
        }
                        
        if((conf=fopen(CONF_FILE, "r")) == NULL){
                perror("alarm:");
                return 0;        
        }

        for(y=0;(fgets(lbuf, 200, conf) != NULL);y++)
        {
                len=strlen(lbuf);                /*Don't count blank lines*/
                z=1;
                for(x=0;x<len;x++){
                        if(lbuf[x] == '\t' || lbuf[x] == ' ')
                                z++;
                }
                if(len==z) continue;                

             /*   puts("Newline proc\n");*/

                if((pt = strchr(lbuf, '\n')) != NULL)   /*rm extra newline*/
                        *pt = '\0';
                else 
                        return 1;              

            /*    puts("Comment proc\n");*/

                if((pt = strchr(lbuf, '#')) != NULL){    /*allow comments*/
                       /* for(x=0;;x++){
                                if(*(pt+x) == '\0') break;
                                else *(pt+x) = '\0';
                        }
                        if(strlen(lbuf) == 0)
                                continue;*/

                        while(*pt){
                                *pt = '\0';
                                pt++;
                        }
                        
                        len=strlen(lbuf);
                        if(len == 0) continue;
                        
                        z=0;
                        for(x=0;x<len;x++)
                                if(isspace(lbuf[x])) z++;
                        if(len==z) continue;        

                }

                if((name = strtok(lbuf, ":")) == NULL)
                        return 2;
                if((val = strtok(NULL, "")) == NULL)
                        return 2;   
                /*printf("%s\tLen: %d\t Atoi: %d\n", val, strlen(val), atoi(val));*/
                
                if(!strcmp(name, "ACTION")) continue;
                else if(!strcmp(name, "TIME_SET")){
                       if(sscanf(val, "%s %d %d:%d:%d %d", 
                        month, &date, &hh, &mm, &ss, &year) == 6) {

                                if((month_int = valid_month(month)) == -1) 
                                        return 3;


                                /* Since the time in the conf isn't
                                 * In seconds, we need to convert it
                                 * with mktime()
                                 */

                                 thetime.tm_sec = ss;
                                 thetime.tm_min = mm;
                                 thetime.tm_hour = hh;
                                 thetime.tm_mon  = month_int;    
                                 thetime.tm_mday = date;
                                 thetime.tm_year = year - 1900;
                                 thetime.tm_isdst = -1;    

                                if((epoch_sec = mktime(&thetime)) == -1)
                                        return 4;
                                else if(epoch_sec < time(NULL)) 
                                        return 5;
                                else{
                                        alarm_conf.time_set = epoch_sec;
                                        continue;
                                }
                        } else
                                return 6;

                } else
                        return 6;
        }                             


        return -1;
}




char *get_alarm_date()   /* Return date formatted in conf file */
{
        char *ct, *sp;
        ct = ctime(&alarm_conf.time_set);
        sp = strchr(ct, '\n');
         *sp = '\0';
        
        return (ct);
}

void mline(int v, int a, int b, int c)  /* Draw a separater */
{
        int i;
        mvaddch(v, 0, a);
        for(i=0;i<COLS-1;i++){
                if(i == COLS-2)
                        addch(c);
                else
                        addch(b);
        }
}

void drawscr()          /*Draw constant values */
{
        int i;

        border(0, 0, 0, 0, 0, 0, 0, 0);
        /*bkgd(176);*/
        mvaddstr(1, 34, "ALARM V0.20b");

#ifdef USE_SEP
        mline(2,198,205,181);
#endif
        mvaddstr(3, 20, "Alarm Set To:");
        mvaddstr(5, 31, "Valid Key Strokes");
        mvaddstr(7, 8, "F1: About\tF2: Exit & Save\t\tF3: Exit with no Save");

        mvaddstr(3, 34, get_alarm_date());

#ifdef USE_SEP
        mline(8,198,205,181);
#endif
        /*mvaddstr(9, 28, "Wen Aug 3 00:00:00 1998");*/
        /*mvaddstr(10, 30, "999999999/999999999");*/

        mvaddch(16, 6, '%');
        mvaddch(15, 14,ACS_ULCORNER);
        for(i=0;i<50;i++)
                addch(ACS_HLINE);
        mvaddch(16, 14, ACS_VLINE);
        mvaddch(17, 14, ACS_LLCORNER);
        for(i=0;i<50;i++)
                addch(ACS_HLINE);
        mvaddch(15, 51+14, ACS_URCORNER);
        mvaddch(16, 51+14, ACS_VLINE);
        mvaddch(17, 51+14, ACS_LRCORNER);

#ifdef USE_SEP
        mline(20, 198, 205, 181);
#endif
        mvaddstr(23, 20,"(c) 1998 C.D. stingray@bsdbox.dynip.com");
        refresh();
}


int main()      /* Start */
{
        

        /*
          error codes for parse_conf:
          0     fopen failed! 
          1     strchr failed to detect newline char
          2     strtok couldn't split line on : !
          3     Invalid month
          4     mktime() didn't work
          5     time earlier than current time
          6     Bad config parameter
          7     Bad savefile
          8     time earlier than current time (savefile gets deleted)
        */

        int pr, getr;


        pr = parse_conf();
        switch(pr){
                case 0:
                        fputs("fopen() Failed\a\n", stderr);
                        exit(1);
                case 1:
                        fputs("No Newline\a\n", stderr);
                        exit(1);
                case 2:
                        fputs("Couldn't tokenize\a\n", stderr);
                        exit(1);
                case 3:
                        fputs("Invalid month\a\n", stderr);
                        exit(1);
                case 4:
                        fputs("mktime() failed\a\n", stderr);
                        exit(1);
                case 5:
                        fputs("Requested date earlier than current\a\n", stderr);
                        exit(1);
                case 6:
                        fputs("Invalid Config Parameter\a\n", stderr);
                        exit(1);
                case 7:
                        fputs("Invalid Savefile\a\n", stderr);
                        exit(1);
                case 8:
                        fputs("Old savefile has been removed\a\n", stderr);
              
                        if(unlink(SAVE_FILE) == -1){
                                perror("Unlink:");
                        }
                        exit(1);
         } 
        
        /* debug*/
        /* printf("err: %d\n");
         printf("time_set: %d\n", alarm_conf.time_set);
         printf("difftime: %d\n", alarm_conf.difftime);
         exit(1);*/
         
        

        initscr();
        signal(SIGINT, (sig_t)quit);

        cbreak();
        noecho();
        refresh();
        keypad(stdscr, TRUE);
        nodelay(stdscr, TRUE);
        leaveok(stdscr, TRUE);

        drawscr();
        while(1)
        {
                getr=getch();
                if(update()==-1){
                        break;
                }            /* update screan */
                
                refresh();        

                if((getr == KEY_F(1)) || (getr == 'a')){
                        about();
                        drawscr();
                       
                }

                else if(getr == KEY_F(2) || getr == 's') save = 1;
                else if(getr == KEY_F(3) || getr == 'x') quit();
                else if(getr == ERR);
                else beep();

                usleep(WAIT_TIME);
                

        }

        endwin();
        putchar('\n');
        puts("End");
        return 0;
}
